DWARF_ADD_FILE_DECL(3)

NAME
dwarf_add_file_decl - add a source file entry to a producer instance

LIBRARY
libdwarf

SYNOPSIS
#include <libdwarf.h>
Dwarf_Unsigned
dwarf_add_file_decl(Dwarf_P_Debug dbg, char *name, Dwarf_Unsigned dirndx, Dwarf_Unsigned mtime, Dwarf_Unsigned size, Dwarf_Error *err);

DESCRIPTION
Function dwarf_add_file_decl() adds a source file entry to a producer instance.

Argument dbg should reference a DWARF producer instance allocated using dwarf_producer_init(3) or dwarf_producer_init_b(3).

Argument name should point to a NUL-terminated string containing the name of the source file.

If the file name in argument name is not a fully qualified pathname, argument dirndx should specify the index of the directory where the source file resides. Otherwise, argument dirndx should be 0. Valid directory indices are those returned by the function dwarf_add_directory_decl(3).

Argument mtime specifies the time when the file was last modified.

Argument size specifies the size of the file in bytes.

If argument err is not NULL, it will be used to store error information in case of an error.

RETURN VALUES
On success, function dwarf_add_file_decl() returns the index value generated for the source file. In case of an error, function dwarf_add_file_decl() returns DW_DLV_NOCOUNT and sets the argument err.

ERRORS
Function dwarf_add_file_decl() can fail with:

[DW_DLE_ARGUMENT]
    Either arguments dbg or name was NULL.

[DW_DLE_ARGUMENT]
    The length of the NUL-teminated string pointed to by argument name was 0.

[DW_DLE_MEMORY]
    An out of memory condition was encountered during the execution of the function.

SEE ALSO
dwarf(3), dwarf_add_directory_decl(3), dwarf_add_line_entry(3), dwarf_lne_end_sequence(3), dwarf_lne_set_address(3), dwarf_producer_init(3), dwarf_producer_init_b(3)